﻿/*
TODO:
	- use mouse position in looping notifier function to only display notifications when user is active (prevent build-up)
		-'persistent alerts' option
	- configurable audio alert
DONE:
	+ option to play a sound on READY
	+ a reset menu item to 'restore removed games'
	+ an 'update now' menu item
	+ fix unknown time remaining logic
	+ options to choose if WAITING and ELIMINATED are hidden
	+ firsr READY notification display time_created, not 24hours left
	+ fix first READY notification to display nothing
	+ when game is removed from list, remember and stop displaying it
	+ sort READY games: least time remaining on top
BUGS:
FIXED:
	+ don't show username alert unless username changes
	+ time remaining unkown should only display one alert
*/
var oClip = framework.audio.open("charge.wav");	oClip.volume = -900;
var sUsername;
var sAudioAlertFile;
var XMLrequest;
var feedData;
var interval;
var blink_on = true;
var blink_interval;
var blinking_items = new Array();
var justOpened = true;
var sCCURL = "http://www.conquerclub.com/rss.php?username=";
var refreshInterval = 60000;
var htmlInstallMessage =  
	"<h4>Time remaining not yet available</h4>"
+	"This game was READY before " + GADGET_NAME + " was installed, so the time remaining is not yet known."
+	"<p><li>Any game that changes to READY from this point on (as long as the gadget is running) will display the time remaining until you miss the turn."
+	"<p><li>If a game changes to READY when Google Desktop (or this gadget) are not running, the gadget cannot know the time remaining.  <b>For best results, leave your computer on with Google Desktop running.</b>"
+	"<p><li>For now, follow the link above to open this game in your browser on conquerclub.com.<br>"

var htmlChangedWhileDownMessage =
	"<h4>Time remaining unkown.</h4>"
+	"The status of this game changed to READY when " + GADGET_NAME + " was not running, or was monitoring games for another username."
+	"<p>To prevent this, leave your computer on with " + GADGET_NAME + " running, and avoid changing the username."

function DoDownloadFeed() {
	if ( DownloadFeed() == false ) { return; }
	if ( interval ) { ClearInterval(interval); }
	interval = SetInterval("DownloadFeed()", refreshInterval);
}	


plugin.onAddCustomMenuItems = addMenuItem;
function addMenuItem(menu) {
	menu.AddItem("Update Now", 0, MenuCommand);
	menu.AddItem("Restore Removed Games", 0, MenuCommand);
}

function MenuCommand(action) {
	if ( action == "Restore Removed Games" ) { options.putValue("removed", ""); }
	DoDownloadFeed()
}

function view_onOpen() {
	cnArea.contentFlags = gddContentFlagHaveDetails;
	view.caption = GADGET_NAME;

	sUsername = options.getValue("usernameText");
	if ( sUsername == "" || sUsername == null ) {
		sUsername = utils.prompt("Enter your Conquer Club username:", "")
		options.putValue("usernameText", sUsername);
		options.putValue("readyCB", true);
		options.putValue("elimCB", true);
		options.putValue("newCB", true);
		options.putValue("roundCB", false);
		options.putValue("soundCB", true);
		options.putValue("hideWaitCB", false);
		options.putValue("hideElimCB", false);
		options.putValue("noticeText", 12);
	}
	if ( DownloadFeed() == false ) { return; }
	interval = SetInterval("DownloadFeed()", refreshInterval);
}
var ans = true;
function onOptionChanged() {
	if ( event.propertyName == "usernameText" && justOpened == false && ans == true && options.getValue("usernameText") != sUsername ) {
		ans = confirm("Are you sure you want to change the username?\n\nIf one of " + sUsername + "'s games changes to READY while watching another username, the time-remaining-until-missed-turn will be unkown...");
		if ( ans == false ) { options.putValue("usernameText", sUsername); ans = true; return; }
		justOpened = true;
	}
	if ( event.propertyName == "optionsChanged") {
		if ( DownloadFeed() == false ) { return; }
		DoDownloadFeed();
	}
}

function DownloadFeed() {
	sUsername = options.getValue("usernameText");
	if ( sUsername == "" || sUsername == null ) {
		if ( interval ) { ClearInterval(interval); }
		alert("No username was entered. Enter a username in the Options dialog");
		view.caption = "No username.";
		cnArea.removeAllContentItems();
		return false;
	}
	var feedURL = sCCURL + sUsername;
	//var feedURL = "http://neo/cc.xml";

	view.caption = "Loading...";
	XMLrequest = new XMLHttpRequest();
	XMLrequest.onreadystatechange = ProcessFeed;
	XMLrequest.open("GET", feedURL, true);
	XMLrequest.setRequestHeader("Cache-Control", "no-cache");
	XMLrequest.send(null);
}

function Blink() {
	for ( x in blinking_items ) {
		if ( blink_on == true ) {
			blinking_items[parseInt(x)].image = graphics.loadImage("READY.gif");
		} else {
			blinking_items[parseInt(x)].image = graphics.loadImage("exclaim1.gif");
		}
	}

	if ( blink_on == true ) {
			blink_on = false;
	} else {
			blink_on = true;
	}
}

function GetTagText(tagName, oTag) {
	var result = oTag.getElementsByTagName(tagName)[0];
	if ( !result ) { return "" };
	return result.text;
}

function GetGameInfo(iTitle, x) {
	var a = iTitle.split(" ");
	switch (x) {
	   case "game":		return a[1];
	   case "round":	return parseInt(a[3]);
	   case "status":	return a[5];
	}
}

function DateFromString(sDate, TZ) {
	var aDate = new Date();

	switch (TZ) {
	   case "GMT":		aDate.setMinutes(aDate.getMinutes() + aDate.getTimezoneOffset()); break;
	   case "local":	//fall through. local time is the default
	}

	if ( sDate == "" ) {
		return aDate;
	}

	var ms = Date.parse(sDate);
	aDate.setTime(ms);
	return aDate;
}

function sortNumber(a,b) { return b - a; }

function onDetailsView(item) {
	var html_for_details_view = '<html><head><style type="text/css">body {font-size: 12px;}</style></head><body><p>';
	html_for_details_view += item.snippet;
	html_for_details_view += "</p></body></html>";

	var control = new DetailsView();
	control.SetContent("", item.time_created, html_for_details_view, true, item.layout);
	control.html_content = true;

	var details = new Object();
	details.details_control = control;

	return details;
}

function onRemoveItem(item) {
	a = item.heading.split(".");
	options.putValue("removed", options.getValue("removed") + "~" + a[0] + "~");
}

function ProcessFeed() {
	/* readyStates:
	1 = loading
	2 = loaded
	3 = interactive
	4 = complete
	*/
	if ( XMLrequest.readyState != 4 ) { return; }
	if ( XMLrequest.status != 200 ) {
		view.caption = "Error downloading feed: " + sCCURL + sUsername;
		XMLrequest = null;
		return;
	}

	//something was downloaded
	if ( XMLrequest.responseXML == null ) {
		view.caption = "Invalid XML feed";
		return;
	}

	//put the downloaded xml-formatted text into an xmlDOM object
	var feedText = XMLrequest.responseText;
	feedData = new ActiveXObject("Microsoft.XMLDOM");
	feedData.async = "false";
	feedData.loadXML(feedText);

	//make sure we downloaded a valid rss feed
	var rssTags = feedData.getElementsByTagName('rss');
	if ( rssTags == null || rssTags[0] == null ) {
		view.caption = "Invalid RSS data";
		return;
	}
	
	var channelTags = feedData.getElementsByTagName('channel');
	var channelTag = channelTags[0];
	var itemTags = channelTag.getElementsByTagName('item');
	if ( itemTags == null ) { view.caption = "No games found for " + sUsername; return; }

	//initialize arrays for games by status; and indexes for each to zero
	var aREADY	= new Array();
	var aPLAYING	= new Array();
	var aWAITING	= new Array();
	var aELIMINATED	= new Array();

	cnArea.removeAllContentItems();

	//process each <item> tag in the rss feed (each representing an active game)
	for ( var i = itemTags.length - 1; i > -1; i-- ) {
		var itemTag	= itemTags[i];
		var iTitle	= GetTagText('title', itemTag);
		var iLink	= GetTagText('link', itemTag);
		var iDesc	= ""; //"<h4>" + iTitle + "</h4>";
		var timeDataAvailable;
		var statusChangedWhileDown;
		var gadgetJustInstalled;

		//get the game number, which is also our dictionary word
		var gameNumber	= GetGameInfo(iTitle, "game");
		switch ( gameNumber ) {
		   case "user_id":
			view.caption = "bad username";
			alert(iTitle);
			return false;
		   case "is":
			view.caption = sUsername + ": no active games";
			alert(iTitle);
			return false;
		}
		if ( options.getValue("removed").indexOf("~" + gameNumber + "~") > -1 ) { continue; }

		//get the new round and status from the title
		var newRound	= GetGameInfo(iTitle, "round");
		var newStatus	= GetGameInfo(iTitle, "status");
		var newDate	= "";
		iHeading = gameNumber + "." + newRound + "." + newStatus;

		var displayNotification	= false;
		var cItem		= new ContentItem();
		cItem.flags		= gddContentItemFlagLeftIcon;

		//-------------------------------------------------------------------------------------------------
		// set or retrieve old values
		if ( !options.exists(gameNumber) ) {

			if ( justOpened == true ) {
				timeDataAvailable = "false";
				statusChangedWhileDown = "true";

			} else if ( options.getValue("installed") == "true" ) {
				iDesc += "<h4>Game has initialized</h4>";
				timeDataAvailable = "true";
				gadgetJustInstalled = "false";
				//show an alert (if box is checked) 
				if ( options.getValue("newCB") == true ) { displayNotification = true; }
			} 

			if ( options.getValue("installed") != "true" ) { gadgetJustInstalled = "true"; }

			var oldDate	= DateFromString(GetTagText('pubDate', itemTag), "GMT");
			var oldRound	= newRound;
			var oldStatus	= newStatus;

		} else {
			//get the old info from the dictionary
			var a = options.getValue(gameNumber).split("|");
			var oldRound		= parseInt(a[0]);
			var oldStatus		= a[1];
			var oldDate		= DateFromString(a[2], "GMT");
			timeDataAvailable	= a[3];
			gadgetJustInstalled	= a[4];
			statusChangedWhileDown	= a[5];
		}

		//-------------------------------------------------------------------------------------------------
		//set newDate
		if ( newRound != oldRound || newStatus != oldStatus ) {
			//the round or status has changed
			//set time (newDate) for this game to the time from the feed (currently does not exist, but
			//DateFromString returns current time if pubDate tag is empty)
			newDate = DateFromString(GetTagText('pubDate', itemTag), "GMT");

			if ( justOpened == true ) {
				timeDataAvailable = "false";
				statusChangedWhileDown = "true";
			} else {
				timeDataAvailable = "true";
				statusChangedWhileDown = "false";
			}
			if ( options.exists(gameNumber) ) { gadgetJustInstalled = "false"; }


		} else {
			//otherwise, keep the previous time
			newDate = oldDate;
		}
		//keep the array indexes unique while evaluating newStatus
		newDate.setMinutes(newDate.getMinutes() + i);
		var ix = String(Date.parse(newDate))

		//-------------------------------------------------------------------------------------------------
		//display alert for round increment (if box is checked)
		if ( newRound > oldRound ) {
			if ( options.getValue("roundCB") == true ) { displayNotification = true; }
			iDesc = "<h4>Round " + newRound + " starting</h4>"
		}

		//-------------------------------------------------------------------------------------------------
		//evaluate newStatus
		cItem.time_created	= newDate.getVarDate();
		switch (newStatus) {
		   case "ELIMINATED":
			//if status just changed then display alert
			if ( newStatus != oldStatus && options.getValue("elimCB")  == true ) { displayNotification = true; }
			aELIMINATED[ix]	= cItem;
			break;

		   case "WAITING":
			aWAITING[ix]		= cItem;
			break;

		   case "PLAYING":
			aPLAYING[ix]		= cItem;
			break;

		   case "READY":
			//get time remaining until missed turn
			var dateNow	= DateFromString("", "GMT");
			var old_mins	= parseInt( (newDate.getTime() / 60000) - i );
			var new_mins	= parseInt( dateNow.getTime() / 60000 );
			var mins_left	= parseInt( (24 * 60) - (new_mins - old_mins) );
			var hrs_left	= parseInt( mins_left / 60 );
			var missNotice	= parseInt( options.getValue("noticeText") );
			var s_mins	= String( (mins_left-(hrs_left*60)) );
			if ( s_mins.length == 1 ) { s_mins = "0" + s_mins; }
			var timestring	= String( hrs_left + " hrs " + s_mins + " min" );

			cItem.source	= timestring + " left";

			if ( timeDataAvailable == "false" ) {

				if ( gadgetJustInstalled == "true" ) {
					iDesc += htmlInstallMessage
					if ( options.getValue("readyCB") == true && !options.exists(gameNumber) ) { displayNotification = true; }
					cItem.source = "Time not yet available";

				} else if ( statusChangedWhileDown == "true" ) {
					iDesc += htmlChangedWhileDownMessage;
					if ( justOpened && options.getValue("readyCB") == true ) { displayNotification = true; }
					cItem.source = "Time remaining unkown";
				}

			} else if ( hrs_left < 1 ) {
				iDesc += "<h4>" + mins_left + " minutes until you miss this turn!!</h4>";
				if ( options.getValue("readyCB") == true ) { displayNotification = true; }
				blinking_items.push(cItem);
				if ( blink_interval ) { ClearInterval(blink_interval); }
				blink_interval	= SetInterval("Blink()", 1000);

			} else if ( hrs_left < missNotice && ( 60-(mins_left-(hrs_left*60)) ) <= 1 ) {
				iDesc += "<h4>You have less than " + (hrs_left + 1) + " hours to take this turn!</h4>";
				if ( options.getValue("readyCB") == true ) { displayNotification = true; }

			} else {
				if ( newStatus != oldStatus ) {
					cItem.source = "Go! Conquer!";
					iDesc = DateFromString("", "local");
					if ( options.getValue("readyCB") == true ) { displayNotification = true; }

				} else {
					if ( iDesc.indexOf("initialized") == -1 ) {
						iDesc += "<h4>You have " + timestring + " to take this turn</h4>";
					} else {
						cItem.source = "Game has initialized";
						iDesc = DateFromString("", "local");
					}
					if ( options.getValue("readyCB") == true && !options.exists(gameNumber)) { displayNotification = true; }
				}
			}
			cItem.flags	= gddContentItemFlagLeftIcon + gddContentItemFlagHighlighted;
			aREADY[ix] = cItem;
			break;
		} //end evaluate newStatus

		//-------------------------------------------------------------------------------------------------
		//add remaining elements to content item
		cItem.image		= graphics.loadImage(newStatus + ".gif")
		cItem.layout		= gddContentItemLayoutNews;
		cItem.heading		= iHeading;
		cItem.snippet		= iDesc;
		cItem.open_command	= iLink;
		cItem.onDetailsView	= onDetailsView;
		cItem.onRemoveItem	= onRemoveItem;

		if ( displayNotification  == true ) {
			cnArea.addContentItem(cItem, gddItemDisplayAsNotification);
			if ( options.getValue("soundCB") == true && newStatus == "READY" ) {
				oClip.stop();
				oClip.play();
			}
		}

		//assign the new values to gameNumber
		newDate.setMinutes(newDate.getMinutes() - i);
		options.putValue(gameNumber, newRound + "|" + newStatus + "|" + newDate + "|" + timeDataAvailable + "|" + gadgetJustInstalled + "|" + statusChangedWhileDown);

	} //end items processing

	//-------------------------------------------------------------------------------------------------
	//first sort games by status, then by time remaining
	//
	//sort order (last added goes to top of content area):
	//	eliminated
	//	waiting
	//	playing
	//	ready
	//-------------------------------------------------------------------------------------------------

	var a = new Array(); var i = 0; var n = 0;
	for ( n in aELIMINATED ) { a[i] = Date.parse(aELIMINATED[n].time_created); i++ }
	for ( n in a.sort(sortNumber) ) {
		if ( options.getValue("hideElimCB") == false ) { cnArea.addContentItem(aELIMINATED[a[n]], gddItemDisplayInSidebar); }
	}

	var a = new Array(); var i = 0; var n = 0;
	for ( n in aWAITING ) { a[i] = Date.parse(aWAITING[n].time_created); i++ }
	for ( n in a.sort(sortNumber) ) {
		if ( options.getValue("hideWaitCB") == false ) { cnArea.addContentItem(aWAITING[a[n]], gddItemDisplayInSidebar); }
	}

	var a = new Array(); var i = 0; var n = 0;
	for ( n in aPLAYING ) { a[i] = Date.parse(aPLAYING[n].time_created); i++ }
	for ( n in a.sort(sortNumber) ) { cnArea.addContentItem(aPLAYING[a[n]], gddItemDisplayInSidebar); }

	var a = new Array(); var i = 0; var n = 0;
	for ( n in aREADY ) { a[i] = Date.parse(aREADY[n].time_created); aREADY[n].time_created = Date.parse(); i++ }
	for ( n in a.sort(sortNumber) ) { cnArea.addContentItem(aREADY[a[n]], gddItemDisplayInSidebar); }

	if ( sUsername != "" ) {
		view.caption = sUsername + "'s" + " active games";
	} else {
		view.caption = "ERROR:";
	}
	justOpened = false;
	options.putValue("installed", "true");
}

//end script